
% compute_error_local
% Written by Alessandro Mennuni
%compute error f(Ex1,Ey1,x,y) under local perturbation
%This file is called by dynamic_perturbation

%first compute path under local perturbation and true shocks
x_sim_local=zeros(nx,T);y_sim_local=zeros(ny,T);
x_sim_local_expected=zeros(nx,T);y_sim_local_expected=zeros(ny,T);

x_sim_local(:,1)=x_0-x_ss;%initial state vars
%y_sim=zeros(nx,T);
 
for t=1:T-1
      x_sim_local(:,t+1)=kx+pp_ss* x_sim_local(:,t)+ (1/2)*kron(eye(nx),x_sim_local(:,t)')*gg*x_sim_local(:,t)+sigm_true*eps_s(:,t+1);
      y_sim_local(:,t)=ky+ff_ss*x_sim_local(:,t)+ (1/2)*kron(eye(ny),x_sim_local(:,t)')*ee*x_sim_local(:,t);
      x_sim_local_expected(:,t+1)=kx+pp_ss* x_sim_local(:,t)+ (1/2)*kron(eye(nx),x_sim_local(:,t)')*gg*x_sim_local(:,t);%no shocks for this simul!
      y_sim_local_expected(:,t+1)=ky+ff_ss* x_sim_local_expected(:,t+1)...
          + (1/2)*kron(eye(ny),x_sim_local_expected(:,t+1)')*ee*x_sim_local_expected(:,t+1);%no shocks for this simul!
end
y_sim_local(:,T)=ky+ff_ss*x_sim_local(:,T)+ (1/2)*kron(eye(ny),x_sim_local(:,T)')*ee*x_sim_local(:,T);
%y_sim_expected(:,1)=y_sim(:,1);
%x_sim_expected(:,1)=x_sim(:,1);

y_sim_local=y_sim_local+y_ss*ones(1,T);
x_sim_local=x_sim_local+x_ss*ones(1,T);
y_sim_local_expected=y_sim_local_expected+y_ss*ones(1,T);
x_sim_local_expected=x_sim_local_expected+x_ss*ones(1,T);



 
error_local=zeros(nx+ny,TT);%local perturb
%ys(:,1)=y-x_ss(nx+1:nx+ny)';
for t=1:TT-1
     %%errors on the equilibrium conditions
    
    x_t=[x_sim_local_expected(:,t+1);y_sim_local_expected(:,t+1);x_sim_local(:,t);y_sim_local(:,t)];
    error_local(:,t)=feval(fun,x_t);
    %olg_fun_edu_gend_ind_lab_wage(x_t);
end  
disp('max error_global f(Ex1,Ey1,x,y)') 
disp(max(max(abs(error_global(:,:)))))
disp('max error local f(Ex1,Ey1,x,y)')
disp(max(max(abs(error_local(:,:)))))
disp('how many times smaller is the largest error?')
max(max(abs(error_local(:,:))))/max(max(abs(error_global(:,:))))
